import pygame, sys
from pygame.locals import *
import math
from naoqi import ALProxy
import time

flag=0
goal=[0]*2
initial_label=[0]*2
callibrate=500.0/2
counter=0

pygame.init()

DISPLAY=pygame.display.set_mode((500,500),0,32)
WHITE=(255,255,255)
blue=(0,0,205)
GREEN=(0, 205, 0)
BLACK=(0,0,0)

pygame.draw.rect(DISPLAY,GREEN,Rect((0,0), (500,500)))
goal_image=pygame.image.load('goal.png')
kinect=pygame.image.load('kinect.jpg')
myfont= pygame.font.SysFont("monospace", 15)

def find_theta(y, x):
	slope=math.atan(y/x)*180/3.14159
	print "slope", slope
	if (y<0 and x>0):
		slope=slope+ 360;
	elif x<0:
	  slope=slope+ 180;
	return slope



def findangle(prevx, prevy):
	motion.moveTo(0.08, 0, 0)
	temp=0
	# for temp in range(0, 100000000):
	# 	temp=temp+1
	time.sleep(6)
	print "sleep over"
	# var=raw_input("enter y or n")
	# if var=='y':
	f = open('centroid0')
	centroid = f.readlines()
	print centroid
	centroid=centroid[0].split()		# centroid[0, 1, 2]=[x, y, z] of tracked centroid 
	f.close()
	pygame.draw.line(DISPLAY, WHITE, (-float(centroid[0])*callibrate+callibrate, float(centroid[2])*callibrate), (-prevx*callibrate+callibrate, prevy*callibrate))
	pygame.display.update()	
	#pose=find_theta((float(centroid[2])-prevy), (float(centroid[0])-prevx))
	initial_label[0]=float(centroid[0])
	initial_label[1]=float(centroid[2])
	distance= (goal[1]-float(centroid[2]))*(goal[1]-float(centroid[2])) + (goal[0]-float(centroid[0]))* (goal[0]-float(centroid[0]))
	distance=math.sqrt(distance)
	print "distance", distance
	if distance<0.1:
		tts = ALProxy("ALTextToSpeech", "nao.local", 9559)
		tts.say("Goal position reached! Hurray Yippie")
		return -100
	target_pose=find_theta((prevy-float(centroid[2])), (prevx-float(centroid[0])))
	print "target_pose", target_pose
	
	target_pose2=find_theta((float(goal[1])-float(centroid[2])), (float(goal[0])-float(centroid[0])))
	print "target_pose2", target_pose2
	target_difference=target_pose2-target_pose
	print "target difference", target_difference
	if target_difference>180:
		target_difference=target_difference-360
	elif target_difference<-180:
		target_difference=target_difference+360
	if target_difference>=0:
		target_difference=target_difference-180
	elif target_difference<0:
		target_difference=target_difference+180
	target_theta=target_difference*3.14159/180
	return target_theta

def mover():
	f = open('centroid0')
	centroid = f.readlines()
	print centroid
	centroid=centroid[0].split()		# centroid[0, 1, 2]=[x, y, z] of tracked centroid 
	f.close()
	if counter!=0:
		pygame.draw.line(DISPLAY, WHITE, (-float(centroid[0])*callibrate+callibrate, float(centroid[2])*callibrate), (-initial_label[0]*callibrate+callibrate, initial_label[1]*callibrate))
		pygame.display.update()	
	global counter
	counter=1	
	distance= (goal[1]-float(centroid[2]))*(goal[1]-float(centroid[2])) + (goal[0]-float(centroid[0]))* (goal[0]-float(centroid[0]))
	distance=math.sqrt(distance)
	print "distance2", distance
	if distance<0.1:
		tts = ALProxy("ALTextToSpeech", "nao.local", 9559)
		tts.say("Goal position reached! Hurray Yippie")
		global flag
		flag=1
		return
	target_theta=findangle(float(centroid[0]), float(centroid[2]))
	print target_theta
	if target_theta==-100:
		global flag
		flag=1
		return
	motion.moveTo(0,0, target_theta)
	motion.moveTo(0.3, 0, 0)




while True:
	DISPLAY.blit(kinect, (224, 0))
	event=pygame.event.get()
	for game in event:
		if game.type==pygame.MOUSEBUTTONUP:
			#print pygame.mouse.get_pos()
			DISPLAY.fill(GREEN)
			DISPLAY.blit(kinect, (224, 0))
			goal_from_pygame=pygame.mouse.get_pos()
			DISPLAY.blit(goal_image, goal_from_pygame)
			# goal=raw_input("Enter goal cordinates")
			# goal=goal.split()			# goal[0,1]=[x, y] of target position
			print goal_from_pygame
			print goal
			goal[0]=-(float(goal_from_pygame[0])-callibrate)/callibrate
			goal[1]=float(goal_from_pygame[1])/callibrate
			
			text="("+str(goal[0])+","+str(goal[1])+")"
			label=myfont.render(text, 1, BLACK)
			DISPLAY.blit(label, (goal_from_pygame[0]+15, goal_from_pygame[1]-10))
			pygame.display.update()	
			print "goal=", goal[0], " ", goal[1]
			#not_imp=raw_input("r u sure?? y or n")
			motion = ALProxy("ALMotion", "nao.local", 9559)
			motion.setStiffnesses("Body", 1.0)
			motion.moveInit()
			var=raw_input("enter y or n")
			while var=='y':
				mover()
				if flag==1:
					flag=0
					#DISPLAY.fill(GREEN)
					#DISPLAY.blit(kinect, (224, 0))
					break
				var=raw_input("enter y or n")

		if game.type==QUIT:
			pygame.quit()
			sys.exit()
		pygame.display.update()	
		

